//------------------------------------------
// FBCrypt.java
//

package com.glavsoft.rfb.client;

import com.glavsoft.rfb.client.Aes;
import com.glavsoft.rfb.client.SHA1;
import com.glavsoft.rfb.client.KeyEventMessage;
import java.security.DigestInputStream;
import java.security.MessageDigest;

public class FBCrypt {
	public  int encrypt;
	public  int seq = 0;
	public  int hash[] = new int[5];
   	private static Aes aes;

	/* protocol client message case:x */
	public static final int CASE_FBCRYPT = 7;
	public static final int CASE_SHA = 8;

	/* CONFIG -------------------------- */
	public static boolean KEY_ENCRYPT 		= false;
	public static boolean SCREEN_DECRYPT	= false;
	public static boolean HVM_KBD   		= false;
	public static boolean SHA_MODE 			= true;
	public static boolean RESPONSE_KBD		= false;
	public static boolean RESPONSE_SCREEN	= false;
	public static boolean OVERHEAD			= false;
	public static boolean KEY_EXCHANGE		= true;
	/* ----------------------------------------------*/

	/* KBD_RESPONSE_TIME ---------------- */
	public static long response_start;
	public static long response_end;
	public static boolean pressed = false;
	public static long send_cnt = 0;
	public static long recv_cnt = 0;

	/* SCREEN_RESPONSE_TIME ---------------- */
	public static long rsp_screen_start;
	public static long rsp_screen_end;
	public static boolean rsp_screen_flag = false;
	public static long rsp_screen_send_cnt = 0;
	public static long rsp_screen_recv_cnt = 0;

	/* KBD_OVERHEAD_TIME ---------------- */
	public static long time_start;
	public static long time_end;
	public static final boolean stop = true;
	public static final boolean start = false;

	public static void mystopwatch(boolean button) {
		if ( !button )
			time_start = System.nanoTime();
		else {
			time_end = System.nanoTime();
			if ( OVERHEAD ) {
				double overhead = (double)(time_end-time_start)/1000000;
				System.out.printf("send_time_overhead(ms):%.4f\n",overhead);
				System.out.println(SCREEN_DECRYPT);
			}
		}
	}
	/* ---------------------------------------------*/

	public FBCrypt() {
		try { aes = new Aes(); } 
		catch ( Exception e ) { System.out.println(e); }
	}

	/* create SHA-1 hash */
	private static String createHash(int input, int seq) {
		SHA1 sha1 = new SHA1();
		/* MAX input: 255, num: 1024 */
		String value = String.valueOf(input+seq); // key + seq
		String result = "homurachan";

		try {
			MessageDigest msd = MessageDigest.getInstance("SHA1");
			result = sha1.calculateHash(msd,value);
			System.out.println("SHA1-HASH: "+result+" input+num: "+(input+seq));
		} catch(Exception e) { System.out.println("SHA1-HASH: ERROR"); }

		return result;
	}


	/* string hash -> (4byte_integer)*5 */
	private static int[] string2intSHA1(String hash) {
		String tmp2byteHex[] = new String[10];
		int intHash[] = new int[10];
		int output[]  = new int[5];

		for ( int i=0; i<10; i++ ) {
			/* 2byte */
			tmp2byteHex[i] = "0x"+hash.substring(i*4,(i*4)+4);
			/* string -> int */
			intHash[i] = Integer.decode(tmp2byteHex[i]);
		}

		for ( int i=0; i<5; i++ ) {
			/* combine 2byte+2byte -> 4byte */
			output[i] = ( (intHash[i*2]<<16) | intHash[(i*2)+1] );
			//System.out.printf("output[%d]: 0x%08x %d\n",i,output[i],output[i]);
		}

		return output;
	}


	public void enc_start(int key, boolean down) {

		if ( KEY_EXCHANGE ) {
			try { aes.key_init(); }  /* init session_key */
			catch ( Exception e ) { System.out.println(e); }
		}

		encrypt = aes.kbd_encrypt(key); 

		/* sequence ++ */
		this.seq++; 

		/* set downflag */
		if ( down ) encrypt |= 0x00010000;

		/* set HVM or PV flag */
		if ( HVM_KBD ) 	encrypt |= 0x00100000; // HVM_KBD
		else			encrypt |= 0x00200000; // PV_KBD

		/* set reset flag for RC4 */
		if ( KEY_EXCHANGE ) {
			encrypt  |= 0x01000000;
			KEY_EXCHANGE = false;
		}

		/* set integrity check flag */
		if ( SHA_MODE ) {
			encrypt |= 0x10000000;
			hash = string2intSHA1(createHash(encrypt,seq)); 
		}

		System.out.printf("encrypt:%d(0x%08x) key:%d(0x%02x) sequence:%d \n", encrypt,encrypt,key,key,seq);
	}
}
