/*
 * hypercall.c : FBCrypt hypercall interface
 * 
 */

#include <sys/ioctl.h>
#include <linux/types.h>
#include <fcntl.h>
#include <xenctrl.h>
/* environment dependence */
#include <xen-sys/Linux/privcmd.h> 
#include "fbcrypt.h"
#include <stdarg.h>

#define IOCTL_PRIVCMD_HYPERCALL	\
	_IOC(_IOC_NONE, 'P', 0, sizeof(privcmd_hypercall_t))


static int xc_interface_open_v2(void)
{
    int flags;
    int fd = open("/proc/xen/privcmd", O_RDWR);

    if ( fd == -1 )
    {
        printf("Could not obtain handle on privileged command interface");
        return -1;
    }

    if ( (flags = fcntl(fd, F_GETFD)) < 0 )
    {
        printf("Could not get file handle flags");
		return -1;
    }

    flags |= FD_CLOEXEC;

    if ( fcntl(fd, F_SETFD, flags) < 0 )
    {
        printf("Could not set file handle flags");
		return -1;
    }
    return fd;
}

int hypercall_v2(int op, int cnt, ...)
{
	int i;
	int ret;
	va_list ap;
	int xc_handle = xc_interface_open_v2();
	privcmd_hypercall_t hypercall;

	hypercall.op = op;

	/* cnt <= 5 */
	if ( cnt !=0 ) {
		va_start(ap,cnt);
		for ( i=0; i<cnt; i++ )
			hypercall.arg[i] = (unsigned long)va_arg(ap,void*);
		va_end(ap);
	}

	ret = ioctl(xc_handle, IOCTL_PRIVCMD_HYPERCALL, (unsigned long)&hypercall);
	close(xc_handle);
	return ret;
}

