/*
 * hypercall.c
 *
 */

#include <asm/system.h>
#include <xen/types.h>
#include <xen/time.h>
#include <crypto/fbcrypt/configure.h>

/* HYPERCALL No.40 */
asmlinkage int do_Domain_info(int domid)
{
	Domain_ref_list(domid);
	return 0;
}

/* HYPERCALL No.42 */
asmlinkage int do_get_time_now(int *stop)
{
	static s_time_t start,end;	
	static unsigned long logid = 0;
	if ( *stop == 0 ) {
		start = NOW();
		//printk("do_get_time_now:start:%ld\n",start);
	} else {
		end = NOW();
		printk("%ld:do_get_time_now(ns):%ld\n",logid++,end-start);
	}

	return 0;
}

/* HYPERCALL No.43 */
asmlinkage void do_check_print(unsigned char *s)
{
	printk("CHECK:%s\n",s);
}
