/*-----------------------------------------------
 * xen/fbcrypt/domain_info.h
 *
 * 各ドメインごとにFBCrypt用の情報を保存・参照
 * VMMが保存している情報は関数越しに呼ぶこと
 *
 * configure.h でinclude 済み
 * fbcrypt/ 以下の全てのファイルで使用可能
 * ---------------------------------------------*/

#ifndef DOMAIN_GLOBAL_H_81e4a06d
#define DOMAIN_GLOBAL_H_81e4a06d

typedef struct xs_mfn_flag {
	unsigned long mfn;
	int header_flag;
	unsigned int mem_cons;
	unsigned int mem_prod;
	unsigned int mem_avail;
} xs_mfn_flag;

typedef enum xenstore_data {
	VMM_START,
	VMM_STORE, 
	VMM_VFB,
	VMM_VKBD,
	VMM_VBD,
	VMM_VIF_TX,
	VMM_VIF_RX,
} XS_DATA;

typedef enum virtual_type {
	HVM_DOMAIN,
	PV_DOMAIN
} V_TYPE;

typedef enum encrypt_mode {
	NO_ENCRYPT = 0,
	FBCRYPT_RC4 = 2,
} ENCRYPT_MODE;

/* fbcrypt_domain_list のポインタのみ公開 */
typedef struct fbcrypt_domain_list *dominfo_p;
dominfo_p Domain_get_pointer(int domid);

int Domain_add_list(int domid, V_TYPE type);
int Domain_delete_list(int domid);

/* VMM が持つ情報を出力 */
int Domain_ref_list(int domid);
int Domain_ref_all(void);

int Domain_regist_info(int domid, unsigned long mfn, XS_DATA cmd);
unsigned long Domain_ref_mfn(int domid, XS_DATA cmd);
void* Domain_mfn2map_page(int domid, XS_DATA cmd);


#endif /* DOMAIN_GLOBAL_H_81e4a06d */
