#include <asm/system.h>
#include <xen/types.h>
#include <crypto/fbcrypt/keycode/keycode.h>

#define MYDEBUG_VS_INFO 0

void init_vs(VncState *vs, kbd_layout_t *kbd)
{
	int i;
	vs->kbd_layout = kbd;
	for ( i=0; i<256; i++ ) vs->modifiers_state[i]=0;
}

/* Keyboard en-US  */
void init_vs2(VncState *vs)
{
	int i;
	kbd_layout_t *k;
	key_range_t *kr;

	k = vs->kbd_layout = xmalloc(kbd_layout_t);
	
	for ( i=0; i<256; i++ ) vs->modifiers_state[i]=0;
	for ( i=0; i<512; i++ ) k->keysym2keycode[i]=0;
	k->keysym2keycode[32]=57; k->keysym2keycode[33]=2;
	k->keysym2keycode[34]=40; k->keysym2keycode[35]=4;
	k->keysym2keycode[36]=5;  k->keysym2keycode[37]=6;
	k->keysym2keycode[38]=8;  k->keysym2keycode[39]=40;
	k->keysym2keycode[40]=10; k->keysym2keycode[41]=11;
	k->keysym2keycode[42]=9;  k->keysym2keycode[43]=13;
	k->keysym2keycode[44]=51; k->keysym2keycode[45]=12;
	k->keysym2keycode[46]=52; k->keysym2keycode[47]=53;
	k->keysym2keycode[48]=11; k->keysym2keycode[49]=2;
	k->keysym2keycode[50]=3;  k->keysym2keycode[51]=4;
	k->keysym2keycode[52]=5;  k->keysym2keycode[53]=6;
	k->keysym2keycode[54]=7;  k->keysym2keycode[55]=8;
	k->keysym2keycode[56]=9;  k->keysym2keycode[57]=10;
	k->keysym2keycode[58]=39; k->keysym2keycode[59]=39;
	k->keysym2keycode[60]=51; k->keysym2keycode[61]=13;
	k->keysym2keycode[62]=52; k->keysym2keycode[63]=53;
	k->keysym2keycode[64]=3;  k->keysym2keycode[91]=26;
	k->keysym2keycode[92]=43; k->keysym2keycode[93]=27;
	k->keysym2keycode[94]=7;  k->keysym2keycode[95]=12;
	k->keysym2keycode[96]=41; k->keysym2keycode[97]=30;
	k->keysym2keycode[98]=48; k->keysym2keycode[99]=46;
	k->keysym2keycode[100]=32; k->keysym2keycode[101]=18;
	k->keysym2keycode[102]=33; k->keysym2keycode[103]=34;
	k->keysym2keycode[104]=35; k->keysym2keycode[105]=23;
	k->keysym2keycode[106]=36; k->keysym2keycode[107]=37;
	k->keysym2keycode[108]=38; k->keysym2keycode[109]=50;
	k->keysym2keycode[110]=49; k->keysym2keycode[111]=24;
	k->keysym2keycode[112]=25; k->keysym2keycode[113]=16;
	k->keysym2keycode[114]=19; k->keysym2keycode[115]=31;
	k->keysym2keycode[116]=20; k->keysym2keycode[117]=22;
	k->keysym2keycode[118]=47; k->keysym2keycode[119]=17;
	k->keysym2keycode[120]=45; k->keysym2keycode[121]=21;
	k->keysym2keycode[122]=44; k->keysym2keycode[123]=26;
	k->keysym2keycode[124]=43; k->keysym2keycode[125]=27;
	k->keysym2keycode[126]=41; k->keysym2keycode[166]=86; 

	/* extra keysym & keycode */
	k->keysym2keycode_extra[0].keysym=65506;
	k->keysym2keycode_extra[0].keycode=54;
	k->keysym2keycode_extra[1].keysym=65505;
	k->keysym2keycode_extra[1].keycode=42;
	k->keysym2keycode_extra[2].keysym=65514;
	k->keysym2keycode_extra[2].keycode=184;
	k->keysym2keycode_extra[3].keysym=65406;
	k->keysym2keycode_extra[3].keycode=184;
	k->keysym2keycode_extra[4].keysym=65027;
	k->keysym2keycode_extra[4].keycode=184;
	k->keysym2keycode_extra[5].keysym=65513;
	k->keysym2keycode_extra[5].keycode=56;
	k->keysym2keycode_extra[6].keysym=65508;
	k->keysym2keycode_extra[6].keycode=157;
	k->keysym2keycode_extra[7].keysym=65507;
	k->keysym2keycode_extra[7].keycode=29;
	k->keysym2keycode_extra[8].keysym=65516;
	k->keysym2keycode_extra[8].keycode=220;
	k->keysym2keycode_extra[9].keysym=65515;
	k->keysym2keycode_extra[9].keycode=219;
	k->keysym2keycode_extra[10].keysym=65383;
	k->keysym2keycode_extra[10].keycode=221;
	k->keysym2keycode_extra[11].keysym=65288;
	k->keysym2keycode_extra[11].keycode=14;
	k->keysym2keycode_extra[12].keysym=65289;
	k->keysym2keycode_extra[12].keycode=15;
	k->keysym2keycode_extra[13].keysym=65293;
	k->keysym2keycode_extra[13].keycode=28;
	k->keysym2keycode_extra[14].keysym=65307;
	k->keysym2keycode_extra[14].keycode=1;
	k->keysym2keycode_extra[15].keysym=65470;
	k->keysym2keycode_extra[15].keycode=59;
	k->keysym2keycode_extra[16].keysym=65471;
	k->keysym2keycode_extra[16].keycode=60;
	k->keysym2keycode_extra[17].keysym=65472;
	k->keysym2keycode_extra[17].keycode=61;
	k->keysym2keycode_extra[18].keysym=65473;
	k->keysym2keycode_extra[18].keycode=62;
	k->keysym2keycode_extra[19].keysym=65474;
	k->keysym2keycode_extra[19].keycode=63;
	k->keysym2keycode_extra[20].keysym=65475;
	k->keysym2keycode_extra[20].keycode=64;
	k->keysym2keycode_extra[21].keysym=65476;
	k->keysym2keycode_extra[21].keycode=65;
	k->keysym2keycode_extra[22].keysym=65477;
	k->keysym2keycode_extra[22].keycode=66;
	k->keysym2keycode_extra[23].keysym=65478;
	k->keysym2keycode_extra[23].keycode=67;
	k->keysym2keycode_extra[24].keysym=65479;
	k->keysym2keycode_extra[24].keycode=68;
	k->keysym2keycode_extra[25].keysym=65480;
	k->keysym2keycode_extra[25].keycode=87;
	k->keysym2keycode_extra[26].keysym=65481;
	k->keysym2keycode_extra[26].keycode=88;
	k->keysym2keycode_extra[27].keysym=65377;
	k->keysym2keycode_extra[27].keycode=183;
	k->keysym2keycode_extra[28].keysym=65301;
	k->keysym2keycode_extra[28].keycode=183;
	k->keysym2keycode_extra[29].keysym=65300;
	k->keysym2keycode_extra[29].keycode=70;
	k->keysym2keycode_extra[30].keysym=65379;
	k->keysym2keycode_extra[30].keycode=210;
	k->keysym2keycode_extra[31].keysym=65535;
	k->keysym2keycode_extra[31].keycode=211;
	k->keysym2keycode_extra[32].keysym=65360;
	k->keysym2keycode_extra[32].keycode=199;
	k->keysym2keycode_extra[33].keysym=65367;
	k->keysym2keycode_extra[33].keycode=207;
	k->keysym2keycode_extra[34].keysym=65365;
	k->keysym2keycode_extra[34].keycode=201;
	k->keysym2keycode_extra[35].keysym=65366;
	k->keysym2keycode_extra[35].keycode=209;
	k->keysym2keycode_extra[36].keysym=65361;
	k->keysym2keycode_extra[36].keycode=203;
	k->keysym2keycode_extra[37].keysym=65362;
	k->keysym2keycode_extra[37].keycode=200;
	k->keysym2keycode_extra[38].keysym=65364;
	k->keysym2keycode_extra[38].keycode=208;
	k->keysym2keycode_extra[39].keysym=65363;
	k->keysym2keycode_extra[39].keycode=205;
	k->keysym2keycode_extra[40].keysym=65407;
	k->keysym2keycode_extra[40].keycode=69;
	k->keysym2keycode_extra[41].keysym=65455;
	k->keysym2keycode_extra[41].keycode=181;
	k->keysym2keycode_extra[42].keysym=65450;
	k->keysym2keycode_extra[42].keycode=55;
	k->keysym2keycode_extra[43].keysym=65453;
	k->keysym2keycode_extra[43].keycode=74;
	k->keysym2keycode_extra[44].keysym=65451;
	k->keysym2keycode_extra[44].keycode=78;
	k->keysym2keycode_extra[45].keysym=65421;
	k->keysym2keycode_extra[45].keycode=156;
	k->keysym2keycode_extra[46].keysym=65454;
	k->keysym2keycode_extra[46].keycode=83;
	k->keysym2keycode_extra[47].keysym=65452;
	k->keysym2keycode_extra[47].keycode=83;
	k->keysym2keycode_extra[48].keysym=65439;
	k->keysym2keycode_extra[48].keycode=83;
	k->keysym2keycode_extra[49].keysym=65456;
	k->keysym2keycode_extra[49].keycode=82;
	k->keysym2keycode_extra[50].keysym=65438;
	k->keysym2keycode_extra[50].keycode=82;
	k->keysym2keycode_extra[51].keysym=65457;
	k->keysym2keycode_extra[51].keycode=79;
	k->keysym2keycode_extra[52].keysym=65436;
	k->keysym2keycode_extra[52].keycode=79;
	k->keysym2keycode_extra[53].keysym=65458;
	k->keysym2keycode_extra[53].keycode=80;
	k->keysym2keycode_extra[54].keysym=65433;
	k->keysym2keycode_extra[54].keycode=80;
	k->keysym2keycode_extra[55].keysym=65459;
	k->keysym2keycode_extra[55].keycode=81;
	k->keysym2keycode_extra[56].keysym=65435;
	k->keysym2keycode_extra[56].keycode=81;
	k->keysym2keycode_extra[57].keysym=65460;
	k->keysym2keycode_extra[57].keycode=75;
	k->keysym2keycode_extra[58].keysym=65430;
	k->keysym2keycode_extra[58].keycode=75;
	k->keysym2keycode_extra[59].keysym=65461;
	k->keysym2keycode_extra[59].keycode=76;
	k->keysym2keycode_extra[60].keysym=65437;
	k->keysym2keycode_extra[60].keycode=76;
	k->keysym2keycode_extra[61].keysym=65462;
	k->keysym2keycode_extra[61].keycode=77;
	k->keysym2keycode_extra[62].keysym=65432;
	k->keysym2keycode_extra[62].keycode=77;
	k->keysym2keycode_extra[63].keysym=65463;
	k->keysym2keycode_extra[63].keycode=71;
	k->keysym2keycode_extra[64].keysym=65429;
	k->keysym2keycode_extra[64].keycode=71;
	k->keysym2keycode_extra[65].keysym=65464;
	k->keysym2keycode_extra[65].keycode=72;
	k->keysym2keycode_extra[66].keysym=65431;
	k->keysym2keycode_extra[66].keycode=72;
	k->keysym2keycode_extra[67].keysym=65465;
	k->keysym2keycode_extra[67].keycode=73;
	k->keysym2keycode_extra[68].keysym=65434;
	k->keysym2keycode_extra[68].keycode=73;
	k->keysym2keycode_extra[69].keysym=65509;
	k->keysym2keycode_extra[69].keycode=58;
	for ( i=70; i<256; i++ ) {
		k->keysym2keycode_extra[i].keysym=0;
		k->keysym2keycode_extra[i].keycode=0;
	}

	k->extra_count = 70; /* extra_count */

	/* shift_range */
	kr = k->shift_range = xmalloc(key_range_t);
	kr->start=60; kr->end=60;
	kr = kr->next = xmalloc(key_range_t);
	kr->start=58; kr->end=58;
	kr = kr->next = xmalloc(key_range_t);
	kr->start=124;kr->end=126;
	kr = kr->next = xmalloc(key_range_t);
	kr->start=123;kr->end=123;
	kr = kr->next = xmalloc(key_range_t);
	kr->start=40; kr->end=41;
	kr = kr->next = xmalloc(key_range_t);
	kr->start=42; kr->end=43;
	kr = kr->next = xmalloc(key_range_t);
	kr->start=94; kr->end=95;
	kr = kr->next = xmalloc(key_range_t);
	kr->start=34; kr->end=38;
	kr = kr->next = xmalloc(key_range_t);
	kr->start=63; kr->end=64;
	kr = kr->next = xmalloc(key_range_t);
	kr->start=33; kr->end=33;
	kr = kr->next = xmalloc(key_range_t);
	kr->start=166;kr->end=166;
	kr = kr->next = xmalloc(key_range_t);
	kr->start=62; kr->end=62;

	/* altgr_range */
	kr = k->altgr_range = xmalloc(key_range_t);
	kr->start=166; kr->end=166;
	
	/* keypad_range */
//	kr = k->keypad_range = xmalloc(key_range_t);
//	kr->start=71; kr->end=73;
//	kr = kr->next = xmalloc(key_range_t);
//	kr->start=75; kr->end=77;
//	kr = kr->next = xmalloc(key_range_t);
//	kr->start=79; kr->end=81;
//	kr = kr->next = xmalloc(key_range_t);
//	kr->start=82; kr->end=83;

	/* numlock_range */
	kr = k->numlock_range = xmalloc(key_range_t);
	kr->start=65456; kr->end=65465;
	kr = kr->next = xmalloc(key_range_t);
	kr->start=65452; kr->end=65452;
	kr = kr->next = xmalloc(key_range_t);
	kr->start=65454; kr->end=65454;

	/* localstate_range */
	kr = k->localstate_range = xmalloc(key_range_t);
	kr->start=205; kr->end=205;
	kr = kr->next = xmalloc(key_range_t);
	kr->start=203; kr->end=203;
	kr = kr->next = xmalloc(key_range_t);
	kr->start=200; kr->end=201;
	kr = kr->next = xmalloc(key_range_t);
	kr->start=207; kr->end=208;
	kr = kr->next = xmalloc(key_range_t);
	kr->start=199; kr->end=199;
	kr = kr->next = xmalloc(key_range_t);
	kr->start=209; kr->end=211;
	kr = kr->next = xmalloc(key_range_t);
	kr->start=183; kr->end=183;
	kr = kr->next = xmalloc(key_range_t);
	kr->start=87;  kr->end=88;
	kr = kr->next = xmalloc(key_range_t);
	kr->start=59;  kr->end=68;
	kr = kr->next = xmalloc(key_range_t);
	kr->start=1;   kr->end=1;
	kr = kr->next = xmalloc(key_range_t);
	kr->start=57;  kr->end=57;
	kr = kr->next = xmalloc(key_range_t);
	kr->start=28;  kr->end=28;
	kr = kr->next = xmalloc(key_range_t);
	kr->start=15;  kr->end=15;

	#if MYDEBUG_VS_INFO
	printk("init vs INFO====================促n");
	//printk("language:%s\n",language);
	for (i=0;i<256;i++) 
		printk("vs->modifiers_state[%d]=%d促n",i,vs->modifiers_state[i]);
	for (i=0;i<512;i++) 
		printk("keysym2keycode[%d]=%d促n",i,k->keysym2keycode[i]);
	for (i=0;i<256;i++) 
		printk("keysym2keycode_extra[%d]:keysym:%d,keycode:%d促n",
				i,k->keysym2keycode_extra[i].keysym,k->keysym2keycode_extra[i].keycode);
	printk("extra_count:%d促n",k->extra_count);

	printk("vs key_range ================促n");
	for ( kr=(k->shift_range); kr; kr=(kr->next) )
		printk("shift_range:start:%d,end:%d促n",kr->start,kr->end);
	for ( kr=(k->altgr_range); kr; kr=(kr->next) )
		printk("altgr_range:start:%d,end:%d促n",kr->start,kr->end);
//	for ( kr=(k->keypad_range); kr; kr=(kr->next) )
//		printk("keypad_range:start:%d,end:%d\n",kr->start,kr->end);
	for ( kr=(k->numlock_range); kr; kr=(kr->next) )
		printk("numlock_range:start:%d,end:%d促n",kr->start,kr->end);
	for ( kr=(k->localstate_range); kr; kr=(kr->next) )
		printk("localstate_range:start:%d,end:%d促n",kr->start,kr->end);
	#endif
}

