/*
 * cyassl.h: connect with fbcrypt & cyassl
 *
 */

#ifndef FBCRYPT_CIPHER_H_acb3e827
#define FBCRYPT_CIPHER_H_acb3e827

#include <crypto/fbcrypt/configure.h>

#include "rc4.h"
#include "sha1.h"
#include "aes.h"

/* ============================== RC4 public functions for FBCrypt */
/* fbcrypt/domain_info.c */
int RC4_get_rc4t(dominfo_p p, RC4_table *rc4t);
int RC4_initflag_on(dominfo_p p);
int	RC4_InternalState_Sync(dominfo_p p, RC4_table *rc4t);
int RC4_reset(int domid);
/* RC4 COMMON PV & HVM */
unsigned int RC4_key_decrypt(dominfo_p p, unsigned int input);


/* SHA1 public functions for FBCrypt */
int getSHA(int key, int seq);
int getSHA2(int key, int seq, unsigned int send_hash[]);


/* RSA public functions for FBCrypt */

/* AES -----------------------------------------*/
typedef struct AES_kbd
{
	Aes aes;
	int key_exchange;
	int used;
	byte secretkey[100];
	byte iv[100];
	byte counter[AES_BLOCK_SIZE];
} AES_kbd;

int aes_test(void);
AES_kbd* AES_prepare(dominfo_p src);
unsigned int AES_kbd_decrypt(dominfo_p dominfo, unsigned int input, int reset_key);


#endif /* FBCRYPT_CIPHER_H_acb3e827 */
